# Copyright 2024 Ant Group Co., Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


tensorflow_whitelist = {
    "DType": {},
    "IndexedSlices": {},
    "IndexedSlicesSpec": {},
    "Module": {},
    "Operation": {},
    "OptionalSpec": {},
    "RaggedTensor": {},
    "RaggedTensorSpec": {},
    "SparseTensor": {},
    "SparseTensorSpec": {},
    "Tensor": {},
    "TensorArray": {},
    "TensorArraySpec": {},
    "TensorShape": {},
    "TensorSpec": {},
    "TypeSpec": {},
    "Variable": {},
    "VariableAggregation": {},
    "VariableSynchronization": {},
    "abs": {},
    "acos": {},
    "acosh": {},
    "add": {},
    "add_n": {},
    "approx_top_k": {},
    "argmax": {},
    "argmin": {},
    "argsort": {},
    "as_dtype": {},
    "as_string": {},
    "asin": {},
    "asinh": {},
    "atan": {},
    "atan2": {},
    "atanh": {},
    "batch_to_space": {},
    "bfloat16": {},
    "bitcast": {},
    "bitwise": {
        "bitwise_and": {},
        "bitwise_or": {},
        "bitwise_xor": {},
        "invert": {},
        "left_shift": {},
        "right_shift": {},
    },
    "bool": {},
    "boolean_mask": {},
    "broadcast_dynamic_shape": {},
    "broadcast_static_shape": {},
    "broadcast_to": {},
    "case": {},
    "cast": {},
    "clip_by_global_norm": {},
    "clip_by_norm": {},
    "clip_by_value": {},
    "complex": {},
    "complex128": {},
    "complex64": {},
    "concat": {},
    "cond": {},
    "constant": {},
    "constant_initializer": {},
    "convert_to_tensor": {},
    "cos": {},
    "cosh": {},
    "cumsum": {},
    "custom_gradient": {},
    "divide": {},
    "double": {},
    "dtypes": {
        "DType": {},
        "QUANTIZED_DTYPES": {},
        "as_dtype": {},
        "bfloat16": {},
        "bool": {},
        "cast": {},
        "complex": {},
        "complex128": {},
        "complex64": {},
        "double": {},
        "float16": {},
        "float32": {},
        "float64": {},
        "half": {},
        "int16": {},
        "int32": {},
        "int64": {},
        "int8": {},
        "qint16": {},
        "qint32": {},
        "qint8": {},
        "quint16": {},
        "quint8": {},
        "resource": {},
        "saturate_cast": {},
        "string": {},
        "uint16": {},
        "uint32": {},
        "uint64": {},
        "uint8": {},
        "variant": {},
    },
    "dynamic_partition": {},
    "dynamic_stitch": {},
    "edit_distance": {},
    "eig": {},
    "eigvals": {},
    "einsum": {},
    "ensure_shape": {},
    "equal": {},
    "exp": {},
    "expand_dims": {},
    "extract_volume_patches": {},
    "eye": {},
    "feature_column": {
        "bucketized_column": {},
        "categorical_column_with_hash_bucket": {},
        "categorical_column_with_identity": {},
        "categorical_column_with_vocabulary_file": {},
        "categorical_column_with_vocabulary_list": {},
        "crossed_column": {},
        "embedding_column": {},
        "indicator_column": {},
        "make_parse_example_spec": {},
        "numeric_column": {},
        "sequence_categorical_column_with_hash_bucket": {},
        "sequence_categorical_column_with_identity": {},
        "sequence_categorical_column_with_vocabulary_file": {},
        "sequence_categorical_column_with_vocabulary_list": {},
        "sequence_numeric_column": {},
        "shared_embeddings": {},
        "weighted_categorical_column": {},
    },
    "fill": {},
    "fingerprint": {},
    "float16": {},
    "float32": {},
    "float64": {},
    "floor": {},
    "foldl": {},
    "foldr": {},
    "function": {},
    "gather": {},
    "gather_nd": {},
    "get_static_value": {},
    "grad_pass_through": {},
    "greater": {},
    "greater_equal": {},
    "group": {},
    "half": {},
    "hessians": {},
    "histogram_fixed_width": {},
    "histogram_fixed_width_bins": {},
    "identity": {},
    "identity_n": {},
    "image": {
        "ResizeMethod": {},
        "adjust_brightness": {},
        "adjust_contrast": {},
        "adjust_gamma": {},
        "adjust_hue": {},
        "adjust_jpeg_quality": {},
        "adjust_saturation": {},
        "central_crop": {},
        "combined_non_max_suppression": {},
        "convert_image_dtype": {},
        "crop_and_resize": {},
        "crop_to_bounding_box": {},
        "decode_and_crop_jpeg": {},
        "decode_bmp": {},
        "decode_gif": {},
        "decode_image": {},
        "decode_jpeg": {},
        "decode_png": {},
        "draw_bounding_boxes": {},
        "encode_jpeg": {},
        "encode_png": {},
        "extract_glimpse": {},
        "extract_jpeg_shape": {},
        "extract_patches": {},
        "flip_left_right": {},
        "flip_up_down": {},
        "generate_bounding_box_proposals": {},
        "grayscale_to_rgb": {},
        "hsv_to_rgb": {},
        "image_gradients": {},
        "is_jpeg": {},
        "non_max_suppression": {},
        "non_max_suppression_overlaps": {},
        "non_max_suppression_padded": {},
        "non_max_suppression_with_scores": {},
        "pad_to_bounding_box": {},
        "per_image_standardization": {},
        "psnr": {},
        "random_brightness": {},
        "random_contrast": {},
        "random_crop": {},
        "random_flip_left_right": {},
        "random_flip_up_down": {},
        "random_hue": {},
        "random_jpeg_quality": {},
        "random_saturation": {},
        "resize": {},
        "resize_with_crop_or_pad": {},
        "resize_with_pad": {},
        "rgb_to_grayscale": {},
        "rgb_to_hsv": {},
        "rgb_to_yiq": {},
        "rgb_to_yuv": {},
        "rot90": {},
        "sample_distorted_bounding_box": {},
        "sobel_edges": {},
        "ssim": {},
        "ssim_multiscale": {},
        "stateless_random_brightness": {},
        "stateless_random_contrast": {},
        "stateless_random_crop": {},
        "stateless_random_flip_left_right": {},
        "stateless_random_flip_up_down": {},
        "stateless_random_hue": {},
        "stateless_random_jpeg_quality": {},
        "stateless_random_saturation": {},
        "stateless_sample_distorted_bounding_box": {},
        "total_variation": {},
        "transpose": {},
        "yiq_to_rgb": {},
        "yuv_to_rgb": {},
    },
    "initializers": {
        "Constant": {},
        "GlorotNormal": {},
        "GlorotUniform": {},
        "HeNormal": {},
        "HeUniform": {},
        "Identity": {},
        "Initializer": {},
        "LecunNormal": {},
        "LecunUniform": {},
        "Ones": {},
        "Orthogonal": {},
        "RandomNormal": {},
        "RandomUniform": {},
        "TruncatedNormal": {},
        "VarianceScaling": {},
        "Zeros": {},
        "constant": {},
        "glorot_normal": {},
        "glorot_uniform": {},
        "he_normal": {},
        "he_uniform": {},
        "identity": {},
        "lecun_normal": {},
        "lecun_uniform": {},
        "ones": {},
        "orthogonal": {},
        "random_normal": {},
        "random_uniform": {},
        "truncated_normal": {},
        "variance_scaling": {},
        "zeros": {},
    },
    "int16": {},
    "int32": {},
    "int64": {},
    "int8": {},
    "is_tensor": {},
    "keras": {
        "Input": {},
        "Model": {},
        "Sequential": {},
        "activations": {
            "elu": {},
            "exponential": {},
            "gelu": {},
            "hard_sigmoid": {},
            "linear": {},
            "relu": {},
            "selu": {},
            "sigmoid": {},
            "softmax": {},
            "softplus": {},
            "softsign": {},
            "swish": {},
            "tanh": {},
        },
        "constraints": {
            "Constraint": {},
            "MaxNorm": {},
            "MinMaxNorm": {},
            "NonNeg": {},
            "RadialConstraint": {},
            "UnitNorm": {},
            "max_norm": {},
            "min_max_norm": {},
            "non_neg": {},
            "radial_constraint": {},
            "unit_norm": {},
        },
        "initializers": {
            "Constant": {},
            "GlorotNormal": {},
            "GlorotUniform": {},
            "HeNormal": {},
            "HeUniform": {},
            "Identity": {},
            "Initializer": {},
            "LecunNormal": {},
            "LecunUniform": {},
            "Ones": {},
            "Orthogonal": {},
            "RandomNormal": {},
            "RandomUniform": {},
            "TruncatedNormal": {},
            "VarianceScaling": {},
            "Zeros": {},
            "constant": {},
            "glorot_normal": {},
            "glorot_uniform": {},
            "he_normal": {},
            "he_uniform": {},
            "identity": {},
            "lecun_normal": {},
            "lecun_uniform": {},
            "ones": {},
            "orthogonal": {},
            "random_normal": {},
            "random_uniform": {},
            "truncated_normal": {},
            "variance_scaling": {},
            "zeros": {},
        },
        "layers": {
            "AbstractRNNCell": {},
            "Activation": {},
            "ActivityRegularization": {},
            "Add": {},
            "AdditiveAttention": {},
            "AlphaDropout": {},
            "Attention": {},
            "Average": {},
            "AveragePooling1D": {},
            "AveragePooling2D": {},
            "AveragePooling3D": {},
            "AvgPool1D": {},
            "AvgPool2D": {},
            "AvgPool3D": {},
            "BatchNormalization": {},
            "Bidirectional": {},
            "CategoryEncoding": {},
            "CenterCrop": {},
            "Concatenate": {},
            "Conv1D": {},
            "Conv1DTranspose": {},
            "Conv2D": {},
            "Conv2DTranspose": {},
            "Conv3D": {},
            "Conv3DTranspose": {},
            "ConvLSTM1D": {},
            "ConvLSTM2D": {},
            "ConvLSTM3D": {},
            "Convolution1D": {},
            "Convolution1DTranspose": {},
            "Convolution2D": {},
            "Convolution2DTranspose": {},
            "Convolution3D": {},
            "Convolution3DTranspose": {},
            "Cropping1D": {},
            "Cropping2D": {},
            "Cropping3D": {},
            "Dense": {},
            "DenseFeatures": {},
            "DepthwiseConv1D": {},
            "DepthwiseConv2D": {},
            "Discretization": {},
            "Dot": {},
            "Dropout": {},
            "ELU": {},
            "EinsumDense": {},
            "Embedding": {},
            "Flatten": {},
            "GRU": {},
            "GRUCell": {},
            "GaussianDropout": {},
            "GaussianNoise": {},
            "GlobalAveragePooling1D": {},
            "GlobalAveragePooling2D": {},
            "GlobalAveragePooling3D": {},
            "GlobalAvgPool1D": {},
            "GlobalAvgPool2D": {},
            "GlobalAvgPool3D": {},
            "GlobalMaxPool1D": {},
            "GlobalMaxPool2D": {},
            "GlobalMaxPool3D": {},
            "GlobalMaxPooling1D": {},
            "GlobalMaxPooling2D": {},
            "GlobalMaxPooling3D": {},
            "GroupNormalization": {},
            "Hashing": {},
            "Input": {},
            "InputLayer": {},
            "InputSpec": {},
            "IntegerLookup": {},
            "LSTM": {},
            "LSTMCell": {},
            "Lambda": {},
            "Layer": {},
            "LayerNormalization": {},
            "LeakyReLU": {},
            "LocallyConnected1D": {},
            "LocallyConnected2D": {},
            "Masking": {},
            "MaxPool1D": {},
            "MaxPool2D": {},
            "MaxPool3D": {},
            "MaxPooling1D": {},
            "MaxPooling2D": {},
            "MaxPooling3D": {},
            "Maximum": {},
            "Minimum": {},
            "MultiHeadAttention": {},
            "Multiply": {},
            "Normalization": {},
            "PReLU": {},
            "Permute": {},
            "RNN": {},
            "RandomBrightness": {},
            "RandomContrast": {},
            "RandomCrop": {},
            "RandomFlip": {},
            "RandomHeight": {},
            "RandomRotation": {},
            "RandomTranslation": {},
            "RandomWidth": {},
            "RandomZoom": {},
            "ReLU": {},
            "RepeatVector": {},
            "Rescaling": {},
            "Reshape": {},
            "Resizing": {},
            "SeparableConv1D": {},
            "SeparableConv2D": {},
            "SeparableConvolution1D": {},
            "SeparableConvolution2D": {},
            "SimpleRNN": {},
            "SimpleRNNCell": {},
            "Softmax": {},
            "SpatialDropout1D": {},
            "SpatialDropout2D": {},
            "SpatialDropout3D": {},
            "StackedRNNCells": {},
            "StringLookup": {},
            "Subtract": {},
            "TextVectorization": {},
            "ThresholdedReLU": {},
            "TimeDistributed": {},
            "UnitNormalization": {},
            "UpSampling1D": {},
            "UpSampling2D": {},
            "UpSampling3D": {},
            "Wrapper": {},
            "ZeroPadding1D": {},
            "ZeroPadding2D": {},
            "ZeroPadding3D": {},
            "add": {},
            "average": {},
            "concatenate": {},
            "dot": {},
            "experimental": {
                "EinsumDense": {},
                "RandomFourierFeatures": {},
                "SyncBatchNormalization": {},
                "preprocessing": {},
            },
            "maximum": {},
            "minimum": {},
            "multiply": {},
            "subtract": {},
        },
        "models": {
            "Model": {},
            "Sequential": {},
        },
        "regularizers": {
            "L1": {},
            "L1L2": {},
            "L2": {},
            "OrthogonalRegularizer": {},
            "Regularizer": {},
            "l1": {},
            "l1_l2": {},
            "l2": {},
            "orthogonal_regularizer": {},
        },
        "metrics": {
            "AUC": {},
            "Accuracy": {},
            "BinaryAccuracy": {},
            "BinaryCrossentropy": {},
            "BinaryIoU": {},
            "CategoricalAccuracy": {},
            "CategoricalCrossentropy": {},
            "CategoricalHinge": {},
            "CosineSimilarity": {},
            "FalseNegatives": {},
            "FalsePositives": {},
            "Hinge": {},
            "IoU": {},
            "KLD": {},
            "KLDivergence": {},
            "LogCoshError": {},
            "MAE": {},
            "MAPE": {},
            "MSE": {},
            "MSLE": {},
            "Mean": {},
            "MeanAbsoluteError": {},
            "MeanAbsolutePercentageError": {},
            "MeanIoU": {},
            "MeanMetricWrapper": {},
            "MeanRelativeError": {},
            "MeanSquaredError": {},
            "MeanSquaredLogarithmicError": {},
            "MeanTensor": {},
            "OneHotIoU": {},
            "OneHotMeanIoU": {},
            "Poisson": {},
            "Precision": {},
            "PrecisionAtRecall": {},
            "Recall": {},
            "RecallAtPrecision": {},
            "RootMeanSquaredError": {},
            "SensitivityAtSpecificity": {},
            "SparseCategoricalAccuracy": {},
            "SparseCategoricalCrossentropy": {},
            "SparseTopKCategoricalAccuracy": {},
            "SpecificityAtSensitivity": {},
            "SquaredHinge": {},
            "Sum": {},
            "TopKCategoricalAccuracy": {},
            "TrueNegatives": {},
            "TruePositives": {},
            "binary_accuracy": {},
            "binary_crossentropy": {},
            "binary_focal_crossentropy": {},
            "categorical_accuracy": {},
            "categorical_crossentropy": {},
            "hinge": {},
            "kl_divergence": {},
            "kld": {},
            "kullback_leibler_divergence": {},
            "log_cosh": {},
            "logcosh": {},
            "mae": {},
            "mape": {},
            "mean_absolute_error": {},
            "mean_absolute_percentage_error": {},
            "mean_squared_error": {},
            "mean_squared_logarithmic_error": {},
            "mse": {},
            "msle": {},
            "poisson": {},
            "sparse_categorical_accuracy": {},
            "sparse_categorical_crossentropy": {},
            "sparse_top_k_categorical_accuracy": {},
            "squared_hinge": {},
            "top_k_categorical_accuracy": {},
        },
        "losses": {
            "BinaryCrossentropy": {},
            "BinaryFocalCrossentropy": {},
            "CategoricalCrossentropy": {},
            "CategoricalHinge": {},
            "CosineSimilarity": {},
            "Hinge": {},
            "Huber": {},
            "KLD": {},
            "KLDivergence": {},
            "LogCosh": {},
            "MAE": {},
            "MAPE": {},
            "MSE": {},
            "MSLE": {},
            "MeanAbsoluteError": {},
            "MeanAbsolutePercentageError": {},
            "MeanSquaredError": {},
            "MeanSquaredLogarithmicError": {},
            "Poisson": {},
            "Reduction": {},
            "SparseCategoricalCrossentropy": {},
            "SquaredHinge": {},
            "binary_crossentropy": {},
            "binary_focal_crossentropy": {},
            "categorical_crossentropy": {},
            "categorical_hinge": {},
            "cosine_similarity": {},
            "hinge": {},
            "huber": {},
            "kl_divergence": {},
            "kld": {},
            "kullback_leibler_divergence": {},
            "log_cosh": {},
            "logcosh": {},
            "mae": {},
            "mape": {},
            "mean_absolute_error": {},
            "mean_absolute_percentage_error": {},
            "mean_squared_error": {},
            "mean_squared_logarithmic_error": {},
            "mse": {},
            "msle": {},
            "poisson": {},
            "sparse_categorical_crossentropy": {},
            "squared_hinge": {},
        },
    },
    "less": {},
    "less_equal": {},
    "linalg": {
        "LinearOperator": {},
        "LinearOperatorAdjoint": {},
        "LinearOperatorBlockDiag": {},
        "LinearOperatorBlockLowerTriangular": {},
        "LinearOperatorCirculant": {},
        "LinearOperatorCirculant2D": {},
        "LinearOperatorCirculant3D": {},
        "LinearOperatorComposition": {},
        "LinearOperatorDiag": {},
        "LinearOperatorFullMatrix": {},
        "LinearOperatorHouseholder": {},
        "LinearOperatorIdentity": {},
        "LinearOperatorInversion": {},
        "LinearOperatorKronecker": {},
        "LinearOperatorLowRankUpdate": {},
        "LinearOperatorLowerTriangular": {},
        "LinearOperatorPermutation": {},
        "LinearOperatorScaledIdentity": {},
        "LinearOperatorToeplitz": {},
        "LinearOperatorTridiag": {},
        "LinearOperatorZeros": {},
        "adjoint": {},
        "band_part": {},
        "banded_triangular_solve": {},
        "cholesky": {},
        "cholesky_solve": {},
        "cross": {},
        "det": {},
        "diag": {},
        "diag_part": {},
        "eig": {},
        "eigh": {},
        "eigh_tridiagonal": {},
        "eigvals": {},
        "eigvalsh": {},
        "einsum": {},
        "experimental": {"conjugate_gradient": {}},
        "expm": {},
        "eye": {},
        "global_norm": {},
        "inv": {},
        "l2_normalize": {},
        "logdet": {},
        "logm": {},
        "lstsq": {},
        "lu": {},
        "lu_matrix_inverse": {},
        "lu_reconstruct": {},
        "lu_solve": {},
        "matmul": {},
        "matrix_rank": {},
        "matrix_transpose": {},
        "matvec": {},
        "norm": {},
        "normalize": {},
        "pinv": {},
        "qr": {},
        "set_diag": {},
        "slogdet": {},
        "solve": {},
        "sqrtm": {},
        "svd": {},
        "tensor_diag": {},
        "tensor_diag_part": {},
        "tensordot": {},
        "trace": {},
        "triangular_solve": {},
        "tridiagonal_matmul": {},
        "tridiagonal_solve": {},
    },
    "linspace": {},
    "logical_and": {},
    "logical_not": {},
    "logical_or": {},
    "map_fn": {},
    "math": {
        "abs": {},
        "accumulate_n": {},
        "acos": {},
        "acosh": {},
        "add": {},
        "add_n": {},
        "angle": {},
        "approx_max_k": {},
        "approx_min_k": {},
        "argmax": {},
        "argmin": {},
        "asin": {},
        "asinh": {},
        "atan": {},
        "atan2": {},
        "atanh": {},
        "bessel_i0": {},
        "bessel_i0e": {},
        "bessel_i1": {},
        "bessel_i1e": {},
        "betainc": {},
        "bincount": {},
        "ceil": {},
        "confusion_matrix": {},
        "conj": {},
        "cos": {},
        "cosh": {},
        "count_nonzero": {},
        "cumprod": {},
        "cumsum": {},
        "cumulative_logsumexp": {},
        "digamma": {},
        "divide": {},
        "divide_no_nan": {},
        "equal": {},
        "erf": {},
        "erfc": {},
        "erfcinv": {},
        "erfinv": {},
        "exp": {},
        "expm1": {},
        "floor": {},
        "floordiv": {},
        "floormod": {},
        "greater": {},
        "greater_equal": {},
        "igamma": {},
        "igammac": {},
        "imag": {},
        "in_top_k": {},
        "invert_permutation": {},
        "is_finite": {},
        "is_inf": {},
        "is_nan": {},
        "is_non_decreasing": {},
        "is_strictly_increasing": {},
        "l2_normalize": {},
        "lbeta": {},
        "less": {},
        "less_equal": {},
        "lgamma": {},
        "log": {},
        "log1p": {},
        "log_sigmoid": {},
        "log_softmax": {},
        "logical_and": {},
        "logical_not": {},
        "logical_or": {},
        "logical_xor": {},
        "maximum": {},
        "minimum": {},
        "mod": {},
        "multiply": {},
        "multiply_no_nan": {},
        "ndtri": {},
        "negative": {},
        "nextafter": {},
        "not_equal": {},
        "polygamma": {},
        "polyval": {},
        "pow": {},
        "real": {},
        "reciprocal": {},
        "reciprocal_no_nan": {},
        "reduce_all": {},
        "reduce_any": {},
        "reduce_euclidean_norm": {},
        "reduce_logsumexp": {},
        "reduce_max": {},
        "reduce_mean": {},
        "reduce_min": {},
        "reduce_prod": {},
        "reduce_std": {},
        "reduce_sum": {},
        "reduce_variance": {},
        "rint": {},
        "round": {},
        "rsqrt": {},
        "scalar_mul": {},
        "segment_max": {},
        "segment_mean": {},
        "segment_min": {},
        "segment_prod": {},
        "segment_sum": {},
        "sigmoid": {},
        "sign": {},
        "sin": {},
        "sinh": {},
        "sobol_sample": {},
        "softmax": {},
        "softplus": {},
        "softsign": {},
        "special": {
            "bessel_i0": {},
            "bessel_i0e": {},
            "bessel_i1": {},
            "bessel_i1e": {},
            "bessel_j0": {},
            "bessel_j1": {},
            "bessel_k0": {},
            "bessel_k0e": {},
            "bessel_k1": {},
            "bessel_k1e": {},
            "bessel_y0": {},
            "bessel_y1": {},
            "dawsn": {},
            "expint": {},
            "fresnel_cos": {},
            "fresnel_sin": {},
            "spence": {},
        },
        "sqrt": {},
        "square": {},
        "squared_difference": {},
        "subtract": {},
        "tan": {},
        "tanh": {},
        "top_k": {},
        "truediv": {},
        "unsorted_segment_max": {},
        "unsorted_segment_mean": {},
        "unsorted_segment_min": {},
        "unsorted_segment_prod": {},
        "unsorted_segment_sqrt_n": {},
        "unsorted_segment_sum": {},
        "xdivy": {},
        "xlog1py": {},
        "xlogy": {},
        "zero_fraction": {},
        "zeta": {},
    },
    "matmul": {},
    "matrix_square_root": {},
    "maximum": {},
    "meshgrid": {},
    "minimum": {},
    "multiply": {},
    "negative": {},
    "nest": {
        "assert_same_structure": {},
        "flatten": {},
        "is_nested": {},
        "map_structure": {},
        "pack_sequence_as": {},
    },
    "newaxis": {},
    "nn": {
        "RNNCellDeviceWrapper": {},
        "RNNCellDropoutWrapper": {},
        "RNNCellResidualWrapper": {},
        "all_candidate_sampler": {},
        "approx_max_k": {},
        "approx_min_k": {},
        "atrous_conv2d": {},
        "atrous_conv2d_transpose": {},
        "avg_pool": {},
        "avg_pool1d": {},
        "avg_pool2d": {},
        "avg_pool3d": {},
        "batch_norm_with_global_normalization": {},
        "batch_normalization": {},
        "bias_add": {},
        "collapse_repeated": {},
        "compute_accidental_hits": {},
        "compute_average_loss": {},
        "conv1d": {},
        "conv1d_transpose": {},
        "conv2d": {},
        "conv2d_transpose": {},
        "conv3d": {},
        "conv3d_transpose": {},
        "conv_transpose": {},
        "convolution": {},
        "crelu": {},
        "ctc_beam_search_decoder": {},
        "ctc_greedy_decoder": {},
        "ctc_loss": {},
        "ctc_unique_labels": {},
        "depth_to_space": {},
        "depthwise_conv2d": {},
        "depthwise_conv2d_backprop_filter": {},
        "depthwise_conv2d_backprop_input": {},
        "dilation2d": {},
        "dropout": {},
        "elu": {},
        "embedding_lookup": {},
        "embedding_lookup_sparse": {},
        "erosion2d": {},
        "experimental": {"stateless_dropout": {}},
        "fixed_unigram_candidate_sampler": {},
        "fractional_avg_pool": {},
        "fractional_max_pool": {},
        "gelu": {},
        "in_top_k": {},
        "isotonic_regression": {},
        "l2_loss": {},
        "l2_normalize": {},
        "leaky_relu": {},
        "learned_unigram_candidate_sampler": {},
        "local_response_normalization": {},
        "log_poisson_loss": {},
        "log_softmax": {},
        "lrn": {},
        "max_pool": {},
        "max_pool1d": {},
        "max_pool2d": {},
        "max_pool3d": {},
        "max_pool_with_argmax": {},
        "moments": {},
        "nce_loss": {},
        "normalize_moments": {},
        "pool": {},
        "relu": {},
        "relu6": {},
        "safe_embedding_lookup_sparse": {},
        "sampled_softmax_loss": {},
        "scale_regularization_loss": {},
        "selu": {},
        "separable_conv2d": {},
        "sigmoid": {},
        "sigmoid_cross_entropy_with_logits": {},
        "silu": {},
        "softmax": {},
        "softmax_cross_entropy_with_logits": {},
        "softplus": {},
        "softsign": {},
        "space_to_batch": {},
        "space_to_depth": {},
        "sparse_softmax_cross_entropy_with_logits": {},
        "sufficient_statistics": {},
        "swish": {},
        "tanh": {},
        "top_k": {},
        "weighted_cross_entropy_with_logits": {},
        "weighted_moments": {},
        "with_space_to_batch": {},
        "zero_fraction": {},
    },
    "no_gradient": {},
    "no_op": {},
    "nondifferentiable_batch_function": {},
    "norm": {},
    "not_equal": {},
    "numpy_function": {},
    "one_hot": {},
    "ones": {},
    "ones_initializer": {},
    "ones_like": {},
    "pad": {},
    "parallel_stack": {},
    "pow": {},
    "qint16": {},
    "qint32": {},
    "qint8": {},
    "quantization": {
        "dequantize": {},
        "fake_quant_with_min_max_args": {},
        "fake_quant_with_min_max_args_gradient": {},
        "fake_quant_with_min_max_vars": {},
        "fake_quant_with_min_max_vars_gradient": {},
        "fake_quant_with_min_max_vars_per_channel": {},
        "fake_quant_with_min_max_vars_per_channel_gradient": {},
        "quantize": {},
        "quantize_and_dequantize": {},
        "quantize_and_dequantize_v2": {},
        "quantized_concat": {},
    },
    "quint16": {},
    "quint8": {},
    "ragged": {
        "boolean_mask": {},
        "constant": {},
        "cross": {},
        "cross_hashed": {},
        "map_flat_values": {},
        "range": {},
        "row_splits_to_segment_ids": {},
        "segment_ids_to_row_splits": {},
        "stack": {},
        "stack_dynamic_partitions": {},
    },
    "random": {
        "Algorithm": {},
        "Generator": {},
        "all_candidate_sampler": {},
        "categorical": {},
        "create_rng_state": {},
        "experimental": {
            "Algorithm": {},
            "Generator": {},
            "create_rng_state": {},
            "get_global_generator": {},
            "index_shuffle": {},
            "set_global_generator": {},
            "stateless_fold_in": {},
            "stateless_shuffle": {},
            "stateless_split": {},
        },
        "fixed_unigram_candidate_sampler": {},
        "gamma": {},
        "get_global_generator": {},
        "learned_unigram_candidate_sampler": {},
        "log_uniform_candidate_sampler": {},
        "normal": {},
        "poisson": {},
        "set_global_generator": {},
        "set_seed": {},
        "shuffle": {},
        "stateless_binomial": {},
        "stateless_categorical": {},
        "stateless_gamma": {},
        "stateless_normal": {},
        "stateless_parameterized_truncated_normal": {},
        "stateless_poisson": {},
        "stateless_truncated_normal": {},
        "stateless_uniform": {},
        "truncated_normal": {},
        "uniform": {},
        "uniform_candidate_sampler": {},
    },
    "random_index_shuffle": {},
    "random_normal_initializer": {},
    "random_uniform_initializer": {},
    "range": {},
    "rank": {},
    "realdiv": {},
    "reduce_all": {},
    "reduce_any": {},
    "reduce_logsumexp": {},
    "reduce_max": {},
    "reduce_mean": {},
    "reduce_min": {},
    "reduce_prod": {},
    "reduce_sum": {},
    "repeat": {},
    "required_space_to_batch_paddings": {},
    "reshape": {},
    "resource": {},
    "reverse": {},
    "reverse_sequence": {},
    "roll": {},
    "round": {},
    "saturate_cast": {},
    "scalar_mul": {},
    "scan": {},
    "scatter_nd": {},
    "searchsorted": {},
    "sequence_mask": {},
    "sets": {"difference": {}, "intersection": {}, "size": {}, "union": {}},
    "shape": {},
    "shape_n": {},
    "sigmoid": {},
    "sign": {},
    "signal": {
        "dct": {},
        "fft": {},
        "fft2d": {},
        "fft3d": {},
        "fftshift": {},
        "frame": {},
        "hamming_window": {},
        "hann_window": {},
        "idct": {},
        "ifft": {},
        "ifft2d": {},
        "ifft3d": {},
        "ifftshift": {},
        "inverse_mdct": {},
        "inverse_stft": {},
        "inverse_stft_window_fn": {},
        "irfft": {},
        "irfft2d": {},
        "irfft3d": {},
        "kaiser_bessel_derived_window": {},
        "kaiser_window": {},
        "linear_to_mel_weight_matrix": {},
        "mdct": {},
        "mfccs_from_log_mel_spectrograms": {},
        "overlap_and_add": {},
        "rfft": {},
        "rfft2d": {},
        "rfft3d": {},
        "stft": {},
        "vorbis_window": {},
    },
    "sin": {},
    "sinh": {},
    "size": {},
    "slice": {},
    "sort": {},
    "space_to_batch": {},
    "space_to_batch_nd": {},
    "sparse": {
        "SparseTensor": {},
        "add": {},
        "bincount": {},
        "concat": {},
        "cross": {},
        "cross_hashed": {},
        "expand_dims": {},
        "eye": {},
        "fill_empty_rows": {},
        "from_dense": {},
        "map_values": {},
        "mask": {},
        "maximum": {},
        "minimum": {},
        "reduce_max": {},
        "reduce_sum": {},
        "reorder": {},
        "reset_shape": {},
        "reshape": {},
        "retain": {},
        "segment_mean": {},
        "segment_sqrt_n": {},
        "segment_sum": {},
        "slice": {},
        "softmax": {},
        "sparse_dense_matmul": {},
        "split": {},
        "to_dense": {},
        "to_indicator": {},
        "transpose": {},
    },
    "split": {},
    "sqrt": {},
    "square": {},
    "squeeze": {},
    "stack": {},
    "stop_gradient": {},
    "strided_slice": {},
    "string": {},
    "strings": {
        "as_string": {},
        "bytes_split": {},
        "format": {},
        "join": {},
        "length": {},
        "lower": {},
        "ngrams": {},
        "reduce_join": {},
        "regex_full_match": {},
        "regex_replace": {},
        "split": {},
        "strip": {},
        "substr": {},
        "to_hash_bucket": {},
        "to_hash_bucket_fast": {},
        "to_hash_bucket_strong": {},
        "to_number": {},
        "unicode_decode": {},
        "unicode_decode_with_offsets": {},
        "unicode_encode": {},
        "unicode_script": {},
        "unicode_split": {},
        "unicode_split_with_offsets": {},
        "unicode_transcode": {},
        "unsorted_segment_join": {},
        "upper": {},
    },
    "subtract": {},
    "switch_case": {},
    "tan": {},
    "tanh": {},
    "tensor_scatter_nd_add": {},
    "tensor_scatter_nd_max": {},
    "tensor_scatter_nd_min": {},
    "tensor_scatter_nd_sub": {},
    "tensor_scatter_nd_update": {},
    "tensordot": {},
    "tile": {},
    "transpose": {},
    "truediv": {},
    "truncatediv": {},
    "truncatemod": {},
    "tuple": {},
    "uint16": {},
    "uint32": {},
    "uint64": {},
    "uint8": {},
    "unique": {},
    "unique_with_counts": {},
    "unravel_index": {},
    "unstack": {},
    "variant": {},
    "vectorized_map": {},
    "where": {},
    "while_loop": {},
    "zeros": {},
    "zeros_initializer": {},
    "zeros_like": {},
}
